<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Big-O</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h2 id="big-o-notation"><strong>Big O Notation</strong></h2>
<ul>
<li><p>Big O helps gives us a precise vocabulary to talk about how our code performs.</p>
<ul>
<li>Useful for discussing trade-offs between different approaches.</li>
<li>Helps us debug things easier.</li>
<li>It also comes up a lot in interviews!</li>
</ul></li>
<li><p>An Example: Comparing two functions that calculate the sum of all numbers from 1 up to n.</p></li>
</ul>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">function</span> <span class="at">addUpTo</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="kw">let</span> total <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-4" title="4">    total <span class="op">+=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="cf">return</span> total<span class="op">;</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Number of operations will grow with n. Would be O(n) or Linear Time.</p>
</blockquote>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">function</span> <span class="at">addUpTo</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="cf">return</span> (n <span class="op">*</span> (n <span class="op">+</span> <span class="dv">1</span>)) / <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Has three simple operations: 1 Multiplication 1 Addition 1 Division. (Regardless of n) Would be O(1) or Constant Time.</p>
</blockquote>
<ul>
<li><p>First we need to consider what makes one implementation better than the other?</p>
<ul>
<li>Faster? (Time Complexity);</li>
<li>Less Memory Intensive (Space Complexity);</li>
<li>More Readable</li>
</ul></li>
<li><p>How can we measure speed?</p>
<ul>
<li>Timers? (Doesn’t work well - not reliable or precise)</li>
<li>Instead we should count the number of simple operations.</li>
</ul></li>
<li>Big O Notation is a way to formalize fuzzy counting.</li>
<li>An algorithm is O(f(n)) if the number of simple operations the computer has to do is eventually less than a constant f(n) times, as n increases.
<ul>
<li>f(n) = n (Linear)</li>
<li>f(n) = n^2 (Quadratic)</li>
<li>f(n) = 1 (Constant)</li>
<li>f(n) could be anything!</li>
</ul></li>
</ul>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> <span class="at">countUpAndDown</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&#39;going up!&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-6" title="6">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&#39;at the top, going down!&#39;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-7" title="7">  <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> n <span class="op">-</span> <span class="dv">1</span><span class="op">;</span> j <span class="op">&gt;=</span><span class="dv">0</span><span class="op">;</span> j<span class="op">--</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-8" title="8">    <span class="va">console</span>.<span class="at">log</span>(j)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-9" title="9">  <span class="op">}</span></a>
<a class="sourceLine" id="cb3-10" title="10">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&#39;Back down, bye!);</span></a>
<a class="sourceLine" id="cb3-11" title="11"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Both loops are O(n) but since we just want the big picture, this entire function would be O(n);</p>
</blockquote>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> <span class="at">printAllPairs</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> j <span class="op">&lt;</span> n<span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-4" title="4">      <span class="va">console</span>.<span class="at">log</span>(i<span class="op">,</span> j)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb4-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Nested loops are never a good thing when trying to write fast code. O(n^2) or Quadratic Time.</p>
</blockquote>
<ul>
<li><p>Constants don’t matter in big O &amp; Smaller Terms don’t matter</p>
<ul>
<li>O(2n) is just O(n) Linear</li>
<li>O(500) is just O(1) Constnat</li>
<li>O(13n^2) is just O(n^2) Quadratic</li>
<li>O(n + 10) is just O(n) Linear</li>
<li>O(1000n + 50) is just O(n) Linear</li>
<li>O(n^2 + 5n + 8) is just O(n^2) Quadratic</li>
</ul></li>
<li><p><strong><code>Big O Shorthands</code></strong></p>
<ul>
<li>Arithmetic Operations are Constant</li>
<li>Variable assignment is constant</li>
<li>Accessing elements in an array (by index) or by object (by key) is constant.</li>
<li>In a loop, the complexity is the length of the loop times the complexity of whatever is inside of the loop.</li>
</ul></li>
<li><p>Additional Examples</p></li>
</ul>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">function</span> <span class="at">logAtLeast5</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> <span class="va">Math</span>.<span class="at">max</span>(<span class="dv">5</span><span class="op">,</span> n)<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-3" title="3">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>O(n) Linear Time</p>
</blockquote>
<div class="sourceCode" id="cb6"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">function</span> <span class="at">logAtMost5</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> <span class="va">Math</span>.<span class="at">min</span>(<span class="dv">5</span><span class="op">,</span> n)<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-3" title="3">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb6-5" title="5"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>O(1) Constant Time.</p>
</blockquote>
<hr />
<h2 id="a-guide-to-big-o-notation"><strong>A Guide to Big-O Notation</strong></h2>
<p><strong>Curating Complexity: A Guide to Big-O Notation</strong></p>
<ul>
<li><p>Why is looking at runtime not a reliable method of calculating time complexity?</p>
<ul>
<li>Not all computers are made equal( some may be stronger and therefore boost our runtime speed )</li>
<li>How many background processes ran concurrently with our program that was being tested?</li>
<li>We also need to ask if our code remains performant if we increase the size of the input.</li>
</ul></li>
<li><p>The real question we need to answering is: <strong><code>How does our performance scale?</code></strong>.</p></li>
</ul>
<p><strong>Big O Notation</strong></p>
<ul>
<li>Big O Notation is a tool for describing the efficiency of algorithms with respect to the size of the input arguments.</li>
<li>Since we use mathematical functions in Big-O, there are a few big picture ideas that we’ll want to keep in mind:
<ul>
<li>The function should be defined by the size of the input.</li>
<li><strong><code>Smaller</code></strong> Big O is better (lower time complexity)</li>
<li>Big O is used to describe the worst case scenario.</li>
<li>Big O is simplified to show only its most dominant mathematical term.</li>
</ul></li>
</ul>
<p><strong>Simplifying Math Terms</strong></p>
<ul>
<li><p>We can use the following rules to simplify the our Big O functions:</p>
<ul>
<li><strong><code>Simplify Products</code></strong> : If the function is a product of many terms, we drop the terms that don’t depend on n.</li>
<li><strong><code>Simplify Sums</code></strong> : If the function is a sum of many terms, we drop the non-dominant terms.</li>
</ul></li>
<li><strong><code>n</code></strong> : size of the input</li>
<li><strong><code>T(f)</code></strong> : unsimplified math function</li>
<li><p><strong><code>O(f)</code></strong> : simplified math function.</p></li>
</ul>
<p><strong><code>Simplifying a Product</code></strong> | Unsimplified | Big-O Simplified | | ——————- | ——————— | | T(5 _ n^2) | O(n^2) Quadratic | | T(100000 _ n) | O(n) Linear | | T( n / 12) | O (n) Linear | | T( 42 _ n _ log(n)) | O(nlog(n)) Log Linear | | T(12) | O(1) Constant |</p>
<p><strong><code>Simplifying a Sum</code></strong> | Unsimplified | Big-O Simplified | | —————- | —————— | | T( n3 + n2 + n ) | O(n^3) | | T( log(n) + 2n ) | O(2^n) Exponential | | T( n + log(n) ) | O(n) Linear | | T( n! + 10n ) | O(n!) Polynomial |</p>
<p><strong><code>Putting it all together</code></strong></p>
<table>
<thead>
<tr class="header">
<th>Unsimplified</th>
<th>Big-O Simplified</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>T( 5n2 + 99n )</td>
<td>O(n^2) Quadratic</td>
</tr>
<tr class="even">
<td>T( 2n + nlog(n) )</td>
<td>O(nlog(n)) Log Linear</td>
</tr>
<tr class="odd">
<td>T( 2n + 5n1000)</td>
<td>O(2^n) Exponential</td>
</tr>
</tbody>
</table>
<ul>
<li>First we apply the product rule to drop all constants.</li>
<li>Then we apply the sum rule to select the single most dominant term.</li>
</ul>
<hr />
<h2 id="complexity-classes"><strong>Complexity Classes</strong></h2>
<p><strong>Common Complexity Classes</strong></p>
<blockquote>
<p>There are 7 major classes in Time Complexity</p>
</blockquote>
<table>
<thead>
<tr class="header">
<th>Big O</th>
<th>Complexity Class Name</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>O(1)</td>
<td>Constant</td>
</tr>
<tr class="even">
<td>O(log(n))</td>
<td>Logarithmic</td>
</tr>
<tr class="odd">
<td>O(n)</td>
<td>Linear</td>
</tr>
<tr class="even">
<td>O(nlog(n))</td>
<td>Loglinear, Linearithmetic, Quasilinear</td>
</tr>
<tr class="odd">
<td>O(nc) - O(n2), O(n3), etc.</td>
<td>Polynomial</td>
</tr>
<tr class="even">
<td>O(cn) - O(2n), O(3n), etc.</td>
<td>Exponential</td>
</tr>
<tr class="odd">
<td>O(n!)</td>
<td>Factorial</td>
</tr>
</tbody>
</table>
<ul>
<li><p><strong><code>O(1) Constant</code></strong></p>
<ul>
<li>The algorithm takes roughly the same number of steps for any input size.</li>
</ul>
<div class="sourceCode" id="cb7"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="co">// O(1)</span></a>
<a class="sourceLine" id="cb7-2" title="2"><span class="kw">function</span> <span class="at">constant1</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-3" title="3">  <span class="cf">return</span> n <span class="op">*</span> <span class="dv">2</span> <span class="op">+</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb7-4" title="4"><span class="op">}</span></a>
<a class="sourceLine" id="cb7-5" title="5"></a>
<a class="sourceLine" id="cb7-6" title="6"><span class="co">// O(1)</span></a>
<a class="sourceLine" id="cb7-7" title="7"><span class="kw">function</span> <span class="at">constant2</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-8" title="8">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> <span class="dv">100</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-9" title="9">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb7-11" title="11"><span class="op">}</span></a></code></pre></div></li>
<li><p><strong><code>O(log(n)) Logarithmic</code></strong></p>
<ul>
<li>In most cases our hidden base of Logarithmic time is 2, log complexity algo’s will typically display ‘halving’ the size of the input (like binary search!)</li>
</ul>
<div class="sourceCode" id="cb8"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="co">// O(log(n))</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="kw">function</span> <span class="at">logarithmic1</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-3" title="3">  <span class="cf">if</span> (n <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb8-4" title="4">  <span class="at">logarithmic1</span>(n / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-5" title="5"><span class="op">}</span></a>
<a class="sourceLine" id="cb8-6" title="6"></a>
<a class="sourceLine" id="cb8-7" title="7"><span class="co">// O(log(n))</span></a>
<a class="sourceLine" id="cb8-8" title="8"><span class="kw">function</span> <span class="at">logarithmic2</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-9" title="9">  <span class="kw">let</span> i <span class="op">=</span> n<span class="op">;</span></a>
<a class="sourceLine" id="cb8-10" title="10">  <span class="cf">while</span> (i <span class="op">&gt;</span> <span class="dv">1</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-11" title="11">    i /<span class="op">=</span> <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb8-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb8-13" title="13"><span class="op">}</span></a></code></pre></div></li>
<li><p><strong><code>O(n) Linear</code></strong></p>
<ul>
<li>Linear algo’s will access each item of the input “once”.</li>
</ul>
<div class="sourceCode" id="cb9"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="co">// O(n)</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="kw">function</span> <span class="at">linear1</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-4" title="4">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-6" title="6"><span class="op">}</span></a>
<a class="sourceLine" id="cb9-7" title="7"></a>
<a class="sourceLine" id="cb9-8" title="8"><span class="co">// O(n), where n is the length of the array</span></a>
<a class="sourceLine" id="cb9-9" title="9"><span class="kw">function</span> <span class="at">linear2</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-10" title="10">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-11" title="11">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-13" title="13"><span class="op">}</span></a>
<a class="sourceLine" id="cb9-14" title="14"></a>
<a class="sourceLine" id="cb9-15" title="15"><span class="co">// O(n)</span></a>
<a class="sourceLine" id="cb9-16" title="16"><span class="kw">function</span> <span class="at">linear3</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-17" title="17">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">1</span>) <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb9-18" title="18">  <span class="at">linear3</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb9-19" title="19"><span class="op">}</span></a></code></pre></div></li>
<li><strong><code>O(nlog(n)) Log Linear Time</code></strong>
<ul>
<li>Combination of linear and logarithmic behavior, we will see features from both classes.</li>
<li>Algo’s that are log-linear will use both recursion AND iteration.</li>
</ul></li>
</ul>
<div class="sourceCode" id="cb10"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="co">// O(n * log(n))</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="kw">function</span> <span class="at">loglinear</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-3" title="3">  <span class="cf">if</span> (n <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb10-4" title="4"></a>
<a class="sourceLine" id="cb10-5" title="5">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-6" title="6">    <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb10-8" title="8"></a>
<a class="sourceLine" id="cb10-9" title="9">  <span class="at">loglinear</span>(n / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-10" title="10">  <span class="at">loglinear</span>(n / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-11" title="11"><span class="op">}</span></a></code></pre></div>
<ul>
<li><strong><code>O(nc) Polynomial</code></strong>
<ul>
<li>C is a fixed constant.</li>
</ul></li>
</ul>
<div class="sourceCode" id="cb11"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="co">// O(n^2)</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="kw">function</span> <span class="at">quadratic</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-4" title="4">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> j <span class="op">&lt;=</span> n<span class="op">;</span> j<span class="op">++</span>) <span class="op">{}</span></a>
<a class="sourceLine" id="cb11-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="op">}</span></a>
<a class="sourceLine" id="cb11-7" title="7"></a>
<a class="sourceLine" id="cb11-8" title="8"><span class="co">// O(n^3)</span></a>
<a class="sourceLine" id="cb11-9" title="9"><span class="kw">function</span> <span class="at">cubic</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-10" title="10">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-11" title="11">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> j <span class="op">&lt;=</span> n<span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-12" title="12">      <span class="cf">for</span> (<span class="kw">let</span> k <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> k <span class="op">&lt;=</span> n<span class="op">;</span> k<span class="op">++</span>) <span class="op">{}</span></a>
<a class="sourceLine" id="cb11-13" title="13">    <span class="op">}</span></a>
<a class="sourceLine" id="cb11-14" title="14">  <span class="op">}</span></a>
<a class="sourceLine" id="cb11-15" title="15"><span class="op">}</span></a></code></pre></div>
<ul>
<li><p>Example of Quadratic and Cubic runtime.</p></li>
<li><strong><code>O(c^n) Exponential</code></strong>
<ul>
<li>C is now the number of recursive calls made in each stack frame.</li>
<li>Algo’s with exponential time are VERY SLOW.</li>
</ul></li>
</ul>
<div class="sourceCode" id="cb12"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="co">// O(2^n)</span></a>
<a class="sourceLine" id="cb12-2" title="2"><span class="kw">function</span> <span class="at">exponential2n</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb12-3" title="3">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">1</span>) <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb12-4" title="4">  <span class="at">exponential_2n</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-5" title="5">  <span class="at">exponential_2n</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="op">}</span></a>
<a class="sourceLine" id="cb12-7" title="7"></a>
<a class="sourceLine" id="cb12-8" title="8"><span class="co">// O(3^n)</span></a>
<a class="sourceLine" id="cb12-9" title="9"><span class="kw">function</span> <span class="at">exponential3n</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb12-10" title="10">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">0</span>) <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb12-11" title="11">  <span class="at">exponential_3n</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-12" title="12">  <span class="at">exponential_3n</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-13" title="13">  <span class="at">exponential_3n</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-14" title="14"><span class="op">}</span></a></code></pre></div>
<ul>
<li><strong><code>O(n!) Factorial</code></strong>
<ul>
<li>The largest/ worst complexity (minus DTIME which is n^n);</li>
</ul></li>
</ul>
<hr />
<h2 id="memoization"><strong>Memoization</strong></h2>
<ul>
<li><strong>Memoization</strong> : a design pattern used to reduce the overall number of calculations that can occur in algorithms that use recursive strategies to solve.
<ul>
<li>MZ stores the results of the sub-problems in some other data structure, so that we can avoid duplicate calculations and only ‘solve’ each problem once.</li>
<li>Two features that comprise memoization:
<ul>
<li><ol type="1">
<li>FUNCTION MUST BE RECURSIVE.</li>
</ol></li>
<li><ol start="2" type="1">
<li>Our additional DS is usually an object (we refer to it as our memo!)</li>
</ol></li>
</ul></li>
</ul></li>
</ul>
<p><strong>Memoizing Factorial</strong></p>
<div class="sourceCode" id="cb13"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1"><span class="kw">let</span> memo <span class="op">=</span> <span class="op">{};</span></a>
<a class="sourceLine" id="cb13-2" title="2"></a>
<a class="sourceLine" id="cb13-3" title="3"><span class="kw">function</span> <span class="at">factorial</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb13-4" title="4">  <span class="co">// if this function has calculated factorial(n) previously,</span></a>
<a class="sourceLine" id="cb13-5" title="5">  <span class="co">// fetch the stored result in memo</span></a>
<a class="sourceLine" id="cb13-6" title="6">  <span class="cf">if</span> (n <span class="kw">in</span> memo) <span class="cf">return</span> memo[n]<span class="op">;</span></a>
<a class="sourceLine" id="cb13-7" title="7">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">1</span>) <span class="cf">return</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb13-8" title="8"></a>
<a class="sourceLine" id="cb13-9" title="9">  <span class="co">// otherwise, it havs not calculated factorial(n) previously,</span></a>
<a class="sourceLine" id="cb13-10" title="10">  <span class="co">// so calculate it now, but store the result in case it is</span></a>
<a class="sourceLine" id="cb13-11" title="11">  <span class="co">// needed again in the future</span></a>
<a class="sourceLine" id="cb13-12" title="12">  memo[n] <span class="op">=</span> n <span class="op">*</span> <span class="at">factorial</span>(n <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb13-13" title="13">  <span class="cf">return</span> memo[n]<span class="op">;</span></a>
<a class="sourceLine" id="cb13-14" title="14"><span class="op">}</span></a>
<a class="sourceLine" id="cb13-15" title="15"></a>
<a class="sourceLine" id="cb13-16" title="16"><span class="at">factorial</span>(<span class="dv">6</span>)<span class="op">;</span> <span class="co">// =&gt; 720, requires 6 calls</span></a>
<a class="sourceLine" id="cb13-17" title="17"><span class="at">factorial</span>(<span class="dv">6</span>)<span class="op">;</span> <span class="co">// =&gt; 720, requires 1 call</span></a>
<a class="sourceLine" id="cb13-18" title="18"><span class="at">factorial</span>(<span class="dv">5</span>)<span class="op">;</span> <span class="co">// =&gt; 120, requires 1 call</span></a>
<a class="sourceLine" id="cb13-19" title="19"><span class="at">factorial</span>(<span class="dv">7</span>)<span class="op">;</span> <span class="co">// =&gt; 5040, requires 2 calls</span></a>
<a class="sourceLine" id="cb13-20" title="20"></a>
<a class="sourceLine" id="cb13-21" title="21">memo<span class="op">;</span> <span class="co">// =&gt; { &#39;2&#39;: 2, &#39;3&#39;: 6, &#39;4&#39;: 24, &#39;5&#39;: 120, &#39;6&#39;: 720, &#39;7&#39;: 5040 }</span></a></code></pre></div>
<ul>
<li>Our memo object is <em>mapping</em> out our arguments of factorial to it’s return value.
<ul>
<li>Keep in mind we didn’t improve the speed of our algo.</li>
</ul></li>
</ul>
<p><strong>Memoizing Fibonacci</strong> <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/memoization/images/fib_memoized.png" alt="memofib" /></p>
<ul>
<li>Our time complexity for fibonacci goes from O(2^n) to O(n) after applying memoization.</li>
</ul>
<p><strong>The Memoization Formula</strong></p>
<blockquote>
<p>Rules</p>
</blockquote>
<ol type="1">
<li>Write the unoptimized brute force recursion (make sure it works);</li>
<li>Add memo object as an additional arugmnt .</li>
<li>Add a base case condition that returns the stored value if the function’s argument is in the memo.</li>
<li>Before returning the result of the recursive case, store it in the memo as a value and make the function’s argument it’s key.</li>
</ol>
<blockquote>
<p>Things to remember</p>
</blockquote>
<ol type="1">
<li>When solving DP problems with Memoization, it is helpful to draw out the visual tree first.</li>
<li>When you notice duplicate sub-tree’s that means we can memoize.</li>
</ol>
<hr />
<h2 id="section">**</h2>
<div class="sourceCode" id="cb14"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">function</span> <span class="at">fastFib</span>(n<span class="op">,</span> memo <span class="op">=</span> <span class="op">{}</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb14-2" title="2">  <span class="cf">if</span> (n <span class="kw">in</span> memo) <span class="cf">return</span> memo[n]<span class="op">;</span></a>
<a class="sourceLine" id="cb14-3" title="3">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">1</span> <span class="op">||</span> n <span class="op">===</span> <span class="dv">2</span>) <span class="cf">return</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-4" title="4"></a>
<a class="sourceLine" id="cb14-5" title="5">  memo[n] <span class="op">=</span> <span class="at">fastFib</span>(n <span class="op">-</span> <span class="dv">1</span><span class="op">,</span> memo) <span class="op">+</span> <span class="at">fastFib</span>(n <span class="op">-</span> <span class="dv">2</span><span class="op">,</span> memo)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-6" title="6">  <span class="cf">return</span> memo[n]<span class="op">;</span></a>
<a class="sourceLine" id="cb14-7" title="7"><span class="op">}</span></a>
<a class="sourceLine" id="cb14-8" title="8"></a>
<a class="sourceLine" id="cb14-9" title="9"><span class="at">fastFib</span>(<span class="dv">6</span>)<span class="op">;</span> <span class="co">// =&gt; 8</span></a>
<a class="sourceLine" id="cb14-10" title="10"><span class="at">fastFib</span>(<span class="dv">50</span>)<span class="op">;</span> <span class="co">// =&gt; 12586269025</span></a></code></pre></div>
<hr />
<h2 id="tabulation"><strong>Tabulation</strong></h2>
<ul>
<li><strong>Tabulation Strategy</strong>
<ul>
<li>Use When:
<ul>
<li>The function is iterative and not recursive.</li>
<li>The accompanying DS is usually an array.</li>
</ul></li>
</ul></li>
</ul>
<div class="sourceCode" id="cb15"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">function</span> <span class="at">fib</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-2" title="2">  <span class="kw">let</span> mostRecentCalcs <span class="op">=</span> [<span class="dv">0</span><span class="op">,</span> <span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb15-3" title="3"></a>
<a class="sourceLine" id="cb15-4" title="4">  <span class="cf">if</span> (n <span class="op">===</span> <span class="dv">0</span>) <span class="cf">return</span> mostRecentCalcs[<span class="dv">0</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb15-5" title="5"></a>
<a class="sourceLine" id="cb15-6" title="6">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">2</span><span class="op">;</span> i <span class="op">&lt;=</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-7" title="7">    <span class="kw">const</span> [secondLast<span class="op">,</span> last] <span class="op">=</span> mostRecentCalcs<span class="op">;</span></a>
<a class="sourceLine" id="cb15-8" title="8">    mostRecentCalcs <span class="op">=</span> [last<span class="op">,</span> secondLast <span class="op">+</span> last]<span class="op">;</span></a>
<a class="sourceLine" id="cb15-9" title="9">  <span class="op">}</span></a>
<a class="sourceLine" id="cb15-10" title="10"></a>
<a class="sourceLine" id="cb15-11" title="11">  <span class="cf">return</span> mostRecentCalcs[<span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb15-12" title="12"><span class="op">}</span></a></code></pre></div>
<ul>
<li>Steps for tabulation
<ul>
<li>Create a table array based off the size of the input.</li>
<li>Initialize some values in the table to ‘answer’ the trivially small subproblem.</li>
<li>Iterate through the array and fill in the remaining entries.</li>
<li>Your final answer is usually the last entry in the table.</li>
</ul></li>
</ul>
<h1 id="class-examples"><strong>Class Examples</strong></h1>
<h2 id="example-of-linear-search"><strong>Example of Linear Search</strong></h2>
<div class="sourceCode" id="cb16"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="kw">function</span> <span class="at">search</span>(array<span class="op">,</span> term) <span class="op">{</span></a>
<a class="sourceLine" id="cb16-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb16-3" title="3">    <span class="cf">if</span> (array[i] <span class="op">===</span> term) <span class="op">{</span></a>
<a class="sourceLine" id="cb16-4" title="4">      <span class="cf">return</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb16-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb16-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb16-7" title="7">  <span class="cf">return</span> <span class="dv">-1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb16-8" title="8"><span class="op">}</span></a></code></pre></div>
<ul>
<li>Worst Case Scenario: The term does not even exist in the array.</li>
<li>Meaning: If it doesn’t exist then our for loop would run until the end therefore making our time complexity O(n).</li>
</ul>
<h2 id="example-of-binary-search"><strong>Example of Binary Search</strong></h2>
<div class="sourceCode" id="cb17"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1"><span class="kw">function</span> <span class="at">binarySearch</span>(arr<span class="op">,</span> x<span class="op">,</span> start<span class="op">,</span> end) <span class="op">{</span></a>
<a class="sourceLine" id="cb17-2" title="2">  <span class="cf">if</span> (start <span class="op">&gt;</span> end) <span class="cf">return</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb17-3" title="3"></a>
<a class="sourceLine" id="cb17-4" title="4">  <span class="kw">let</span> mid <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>((start <span class="op">+</span> end) / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-5" title="5">  <span class="cf">if</span> (arr[mid] <span class="op">===</span> x) <span class="cf">return</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb17-6" title="6"></a>
<a class="sourceLine" id="cb17-7" title="7">  <span class="cf">if</span> (arr[mid] <span class="op">&gt;</span> x) <span class="op">{</span></a>
<a class="sourceLine" id="cb17-8" title="8">    <span class="cf">return</span> <span class="at">binarySearch</span>(arr<span class="op">,</span> x<span class="op">,</span> start<span class="op">,</span> mid <span class="op">-</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-9" title="9">  <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb17-10" title="10">    <span class="cf">return</span> <span class="at">binarySearch</span>(arr<span class="op">,</span> x<span class="op">,</span> mid <span class="op">+</span> <span class="dv">1</span><span class="op">,</span> end)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb17-12" title="12"><span class="op">}</span></a></code></pre></div>
<ul>
<li>Must be conducted on a sorted array.</li>
<li>Binary search is logarithmic time, not exponential b/c n is cut down by two, not growing.</li>
<li>Binary Search is part of Divide and Conquer.</li>
</ul>
<h2 id="example-of-merge-sort"><strong>Example of Merge Sort</strong></h2>
<div class="sourceCode" id="cb18"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb18-1" title="1"><span class="kw">function</span> <span class="at">merge</span>(leftArray<span class="op">,</span> rightArray) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-2" title="2">  <span class="kw">const</span> sorted <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb18-3" title="3">  <span class="cf">while</span> (<span class="va">letArray</span>.<span class="at">length</span> <span class="op">&gt;</span> <span class="dv">0</span> <span class="op">&amp;&amp;</span> <span class="va">rightArray</span>.<span class="at">length</span> <span class="op">&gt;</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-4" title="4">    <span class="kw">const</span> leftItem <span class="op">=</span> leftArray[<span class="dv">0</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb18-5" title="5">    <span class="kw">const</span> rightItem <span class="op">=</span> rightArray[<span class="dv">0</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb18-6" title="6"></a>
<a class="sourceLine" id="cb18-7" title="7">    <span class="cf">if</span> (leftItem <span class="op">&gt;</span> rightItem) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-8" title="8">      <span class="va">sorted</span>.<span class="at">push</span>(rightItem)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-9" title="9">      <span class="va">rightArray</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb18-10" title="10">    <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb18-11" title="11">      <span class="va">sorted</span>.<span class="at">push</span>(leftItem)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-12" title="12">      <span class="va">leftArray</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb18-13" title="13">    <span class="op">}</span></a>
<a class="sourceLine" id="cb18-14" title="14">  <span class="op">}</span></a>
<a class="sourceLine" id="cb18-15" title="15"></a>
<a class="sourceLine" id="cb18-16" title="16">  <span class="cf">while</span> (<span class="va">leftArray</span>.<span class="at">length</span> <span class="op">!==</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-17" title="17">    <span class="kw">const</span> value <span class="op">=</span> <span class="va">leftArray</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb18-18" title="18">    <span class="va">sorted</span>.<span class="at">push</span>(value)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-19" title="19">  <span class="op">}</span></a>
<a class="sourceLine" id="cb18-20" title="20"></a>
<a class="sourceLine" id="cb18-21" title="21">  <span class="cf">while</span> (<span class="va">rightArray</span>.<span class="at">length</span> <span class="op">!==</span> <span class="dv">0</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-22" title="22">    <span class="kw">const</span> value <span class="op">=</span> <span class="va">rightArray</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb18-23" title="23">    <span class="va">sorted</span>.<span class="at">push</span>(value)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-24" title="24">  <span class="op">}</span></a>
<a class="sourceLine" id="cb18-25" title="25"></a>
<a class="sourceLine" id="cb18-26" title="26">  <span class="cf">return</span> sorted<span class="op">;</span></a>
<a class="sourceLine" id="cb18-27" title="27"><span class="op">}</span></a>
<a class="sourceLine" id="cb18-28" title="28"></a>
<a class="sourceLine" id="cb18-29" title="29"><span class="kw">function</span> <span class="at">mergeSort</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-30" title="30">  <span class="kw">const</span> length <span class="op">=</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb18-31" title="31">  <span class="cf">if</span> (length <span class="op">===</span> <span class="dv">1</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb18-32" title="32">    <span class="cf">return</span> array<span class="op">;</span></a>
<a class="sourceLine" id="cb18-33" title="33">  <span class="op">}</span></a>
<a class="sourceLine" id="cb18-34" title="34"></a>
<a class="sourceLine" id="cb18-35" title="35">  <span class="kw">const</span> middleIndex <span class="op">=</span> <span class="va">Math</span>.<span class="at">ceil</span>(length / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-36" title="36">  <span class="kw">const</span> leftArray <span class="op">=</span> <span class="va">array</span>.<span class="at">slice</span>(<span class="dv">0</span><span class="op">,</span> middleIndex)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-37" title="37">  <span class="kw">const</span> rightArray <span class="op">=</span> <span class="va">array</span>.<span class="at">slice</span>(middleIndex<span class="op">,</span> length)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-38" title="38"></a>
<a class="sourceLine" id="cb18-39" title="39">  leftArray <span class="op">=</span> <span class="at">mergeSort</span>(leftArray)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-40" title="40">  rightArray <span class="op">=</span> <span class="at">mergeSort</span>(rightArray)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-41" title="41"></a>
<a class="sourceLine" id="cb18-42" title="42">  <span class="cf">return</span> <span class="at">merge</span>(leftArray<span class="op">,</span> rightArray)<span class="op">;</span></a>
<a class="sourceLine" id="cb18-43" title="43"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="example-of-bubble-sort"><strong>Example of Bubble Sort</strong></h2>
<div class="sourceCode" id="cb19"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb19-1" title="1"><span class="kw">function</span> <span class="at">bubbleSort</span>(items) <span class="op">{</span></a>
<a class="sourceLine" id="cb19-2" title="2">  <span class="kw">let</span> length <span class="op">=</span> <span class="va">items</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb19-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> length<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb19-4" title="4">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> j <span class="op">&lt;</span> length <span class="op">-</span> i <span class="op">-</span> <span class="dv">1</span><span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb19-5" title="5">      <span class="cf">if</span> (items[j] <span class="op">&gt;</span> items[j <span class="op">+</span> <span class="dv">1</span>]) <span class="op">{</span></a>
<a class="sourceLine" id="cb19-6" title="6">        <span class="kw">let</span> tmp <span class="op">=</span> items[j]<span class="op">;</span></a>
<a class="sourceLine" id="cb19-7" title="7">        items[j] <span class="op">=</span> items[j <span class="op">+</span> <span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb19-8" title="8">        items[j <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> tmp<span class="op">;</span></a>
<a class="sourceLine" id="cb19-9" title="9">      <span class="op">}</span></a>
<a class="sourceLine" id="cb19-10" title="10">    <span class="op">}</span></a>
<a class="sourceLine" id="cb19-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb19-12" title="12"><span class="op">}</span></a></code></pre></div>
<ul>
<li>Worst Case &amp; Best Case are always the same because it makes nested loops.</li>
<li>Double for loops are polynomial time complexity or more specifically in this case Quadratic big O O(n^2); # <strong>Notes</strong></li>
</ul>
<h2 id="sorting-algorithms"><strong>Sorting Algorithms</strong></h2>
<h2 id="bubble-sort"><strong>Bubble Sort</strong></h2>
<ul>
<li>The first major sorting algorithm one learns in introductory programming courses.</li>
<li>Gives an intro on how to convert unsorted data into sorted data.</li>
<li>It’s almost never used in production code because:
<ul>
<li>It’s not efficient</li>
<li>It’s not commonly used</li>
<li>There is stigma attached to it</li>
</ul></li>
<li><p><strong><code>Bubbling Up</code></strong> : Term that infers that an item <em>is in motion</em>, <em>moving in some direction</em>, and <em>has some final resting destination</em>.</p></li>
<li><p>Bubble sort, sorts an array of integers by bubbling the largest integer to the top. <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/naive_sorting_algorithms/bubble_sort/images/BubbleSort.gif" alt="bubble" /></p></li>
</ul>
<div class="sourceCode" id="cb20"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb20-1" title="1"><span class="co">// Bubble Sort</span></a>
<a class="sourceLine" id="cb20-2" title="2"><span class="kw">function</span> <span class="at">bubble</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb20-3" title="3">  <span class="kw">let</span> sorted <span class="op">=</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb20-4" title="4">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb20-5" title="5">    <span class="kw">let</span> num1 <span class="op">=</span> array[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb20-6" title="6">    <span class="kw">let</span> num2 <span class="op">=</span> array[i <span class="op">+</span> <span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb20-7" title="7">    <span class="cf">if</span> (num1 <span class="op">&gt;</span> num2) <span class="op">{</span></a>
<a class="sourceLine" id="cb20-8" title="8">      array[i <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> num1<span class="op">;</span></a>
<a class="sourceLine" id="cb20-9" title="9">      array[i] <span class="op">=</span> num2<span class="op">;</span></a>
<a class="sourceLine" id="cb20-10" title="10">      sorted <span class="op">=</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb20-11" title="11">    <span class="op">}</span></a>
<a class="sourceLine" id="cb20-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb20-13" title="13">  <span class="cf">if</span> (sorted) <span class="op">{</span></a>
<a class="sourceLine" id="cb20-14" title="14">    <span class="cf">return</span> array<span class="op">;</span></a>
<a class="sourceLine" id="cb20-15" title="15">  <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb20-16" title="16">    <span class="cf">return</span> <span class="at">bubble</span>(array)<span class="op">;</span></a>
<a class="sourceLine" id="cb20-17" title="17">  <span class="op">}</span></a>
<a class="sourceLine" id="cb20-18" title="18"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="selection-sort"><strong>Selection Sort</strong></h2>
<ul>
<li>Selection sort organizes the smallest elements to the start of the array. <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/naive_sorting_algorithms/selection_sort/images/SelectionSort.gif" alt="selection" /></li>
<li>Summary of how Selection Sort should work:
<ol type="1">
<li>Set MIN to location 0</li>
<li>Search the minimum element in the list.</li>
<li>Swap with value at location Min</li>
<li>Increment Min to point to next element.</li>
<li>Repeat until list is sorted.</li>
</ol></li>
</ul>
<div class="sourceCode" id="cb21"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb21-1" title="1"><span class="kw">let</span> selectionSort <span class="op">=</span> (arr) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb21-2" title="2">  <span class="kw">let</span> len <span class="op">=</span> <span class="va">arr</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb21-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> len<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb21-4" title="4">    <span class="kw">let</span> min <span class="op">=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb21-5" title="5">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> i <span class="op">+</span> <span class="dv">1</span><span class="op">;</span> j <span class="op">&lt;</span> len<span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb21-6" title="6">      <span class="cf">if</span> (arr[min] <span class="op">&gt;</span> arr[j]) <span class="op">{</span></a>
<a class="sourceLine" id="cb21-7" title="7">        min <span class="op">=</span> j<span class="op">;</span></a>
<a class="sourceLine" id="cb21-8" title="8">      <span class="op">}</span></a>
<a class="sourceLine" id="cb21-9" title="9">    <span class="op">}</span></a>
<a class="sourceLine" id="cb21-10" title="10">    <span class="cf">if</span> (min <span class="op">!==</span> i) <span class="op">{</span></a>
<a class="sourceLine" id="cb21-11" title="11">      <span class="kw">let</span> tmp <span class="op">=</span> arr[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb21-12" title="12">      arr[i] <span class="op">=</span> arr[min]<span class="op">;</span></a>
<a class="sourceLine" id="cb21-13" title="13">      arr[min] <span class="op">=</span> tmp<span class="op">;</span></a>
<a class="sourceLine" id="cb21-14" title="14">    <span class="op">}</span></a>
<a class="sourceLine" id="cb21-15" title="15">  <span class="op">}</span></a>
<a class="sourceLine" id="cb21-16" title="16">  <span class="cf">return</span> arr<span class="op">;</span></a>
<a class="sourceLine" id="cb21-17" title="17"><span class="op">};</span></a></code></pre></div>
<h2 id="selection-sort-1"><strong>Selection Sort</strong></h2>
<p><strong><code>Time Complexity</code></strong>: Quadratic O(n^2)</p>
<ul>
<li>Our outer loop will contribute O(n) while the inner loop will contribute O(n / 2) on average. Because our loops are nested we will get O(n^2);</li>
</ul>
<p><strong><code>Space Complexity</code></strong>: O(1)</p>
<ul>
<li>Selection Sort will always use the same amount of memory regardless of n.</li>
</ul>
<p><img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/naive_sorting_algorithms/selection_sort/images/SelectionSort.gif" alt="selection" /> <img src="https://www.w3resource.com/w3r_images/selection-short.png" alt="se" /></p>
<blockquote>
<p>Class Solution</p>
</blockquote>
<div class="sourceCode" id="cb22"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb22-1" title="1"><span class="kw">function</span> <span class="at">swap</span>(array<span class="op">,</span> idx1<span class="op">,</span> idx2) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-2" title="2">  [array[idx1]<span class="op">,</span> array[idx2]] <span class="op">=</span> [array[idx2]<span class="op">,</span> array[idx2]]<span class="op">;</span></a>
<a class="sourceLine" id="cb22-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb22-4" title="4"></a>
<a class="sourceLine" id="cb22-5" title="5"><span class="kw">function</span> <span class="at">selectionSort</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-6" title="6">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-7" title="7">    <span class="kw">let</span> lowest <span class="op">=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb22-8" title="8">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> i <span class="op">+</span> <span class="dv">1</span><span class="op">;</span> j <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-9" title="9">      <span class="cf">if</span> (list[j] <span class="op">&lt;</span> list[lowest]) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-10" title="10">        lowest <span class="op">=</span> j<span class="op">;</span></a>
<a class="sourceLine" id="cb22-11" title="11">      <span class="op">}</span></a>
<a class="sourceLine" id="cb22-12" title="12">    <span class="op">}</span></a>
<a class="sourceLine" id="cb22-13" title="13">    <span class="cf">if</span> (place <span class="op">!==</span> i) <span class="op">{</span></a>
<a class="sourceLine" id="cb22-14" title="14">      <span class="at">swap</span>(array<span class="op">,</span> i<span class="op">,</span> lowest)<span class="op">;</span></a>
<a class="sourceLine" id="cb22-15" title="15">    <span class="op">}</span></a>
<a class="sourceLine" id="cb22-16" title="16">  <span class="op">}</span></a>
<a class="sourceLine" id="cb22-17" title="17"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Alt Solution</p>
</blockquote>
<div class="sourceCode" id="cb23"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb23-1" title="1"><span class="kw">function</span> <span class="at">selectionSort</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-3" title="3">    <span class="kw">let</span> lowest <span class="op">=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb23-4" title="4">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> j <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-5" title="5">      <span class="cf">if</span> (array[j] <span class="op">&lt;</span> array[i]) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-6" title="6">        lowest <span class="op">=</span> j<span class="op">;</span></a>
<a class="sourceLine" id="cb23-7" title="7">      <span class="op">}</span></a>
<a class="sourceLine" id="cb23-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb23-9" title="9">    <span class="cf">if</span> (lowest <span class="op">!==</span> i) <span class="op">{</span></a>
<a class="sourceLine" id="cb23-10" title="10">      <span class="kw">let</span> temp <span class="op">=</span> array[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb23-11" title="11">      array[i] <span class="op">=</span> array[lowest]<span class="op">;</span></a>
<a class="sourceLine" id="cb23-12" title="12">      array[lowest] <span class="op">=</span> temp<span class="op">;</span></a>
<a class="sourceLine" id="cb23-13" title="13">    <span class="op">}</span></a>
<a class="sourceLine" id="cb23-14" title="14">  <span class="op">}</span></a>
<a class="sourceLine" id="cb23-15" title="15">  <span class="cf">return</span> array<span class="op">;</span></a>
<a class="sourceLine" id="cb23-16" title="16"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="insertion-sort"><strong>Insertion Sort</strong></h2>
<p><strong><code>Time Complexity</code></strong>: Quadratic O(n^2)</p>
<ul>
<li>Our outer loop will contribute O(n) while the inner loop will contribute O(n / 2) on average. Because our loops are nested we will get O(n^2);</li>
</ul>
<p><strong><code>Space Complexity</code></strong>: O(n)</p>
<ul>
<li>Because we are creating a subArray for each element in the original input, our Space Comlexity becomes linear.</li>
</ul>
<p><img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/naive_sorting_algorithms/insertion_sort/images/InsertionSort.gif" alt="insertion" /> <img src="https://media.geeksforgeeks.org/wp-content/uploads/insertionsort.png" alt="insert" /></p>
<blockquote>
<p>Class Solution</p>
</blockquote>
<div class="sourceCode" id="cb24"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb24-1" title="1"><span class="kw">function</span> <span class="at">insertionSort</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb24-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">array</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb24-3" title="3">    <span class="kw">let</span> value <span class="op">=</span> list[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb24-4" title="4">    <span class="kw">let</span> hole <span class="op">=</span> i<span class="op">;</span></a>
<a class="sourceLine" id="cb24-5" title="5">    <span class="cf">while</span> (hole <span class="op">&gt;</span> <span class="dv">0</span> <span class="op">&amp;&amp;</span> list[hole <span class="op">-</span> <span class="dv">1</span>] <span class="op">&gt;</span> value) <span class="op">{</span></a>
<a class="sourceLine" id="cb24-6" title="6">      list[hole] <span class="op">=</span> list[hole <span class="op">-</span> <span class="dv">1</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb24-7" title="7">      hole<span class="op">--;</span></a>
<a class="sourceLine" id="cb24-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb24-9" title="9">    list[hole] <span class="op">=</span> value<span class="op">;</span></a>
<a class="sourceLine" id="cb24-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb24-11" title="11">  <span class="cf">return</span> array<span class="op">;</span></a>
<a class="sourceLine" id="cb24-12" title="12"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Alt Solution</p>
</blockquote>
<div class="sourceCode" id="cb25"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb25-1" title="1"><span class="kw">function</span> <span class="at">insertionSort</span>(arr) <span class="op">{</span></a>
<a class="sourceLine" id="cb25-2" title="2">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="va">arr</span>.<span class="at">length</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb25-3" title="3">    <span class="kw">let</span> current <span class="op">=</span> arr[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb25-4" title="4">    <span class="kw">let</span> j <span class="op">=</span> i <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb25-5" title="5">    <span class="cf">while</span> (j <span class="op">&gt;</span> <span class="dv">-1</span> <span class="op">&amp;&amp;</span> current <span class="op">&lt;</span> arr[j]) <span class="op">{</span></a>
<a class="sourceLine" id="cb25-6" title="6">      arr[j <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> arr[j]<span class="op">;</span></a>
<a class="sourceLine" id="cb25-7" title="7">      j<span class="op">--;</span></a>
<a class="sourceLine" id="cb25-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb25-9" title="9">    arr[j <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> current<span class="op">;</span></a>
<a class="sourceLine" id="cb25-10" title="10">  <span class="op">}</span></a>
<a class="sourceLine" id="cb25-11" title="11">  <span class="cf">return</span> arr<span class="op">;</span></a>
<a class="sourceLine" id="cb25-12" title="12"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="merge-sort"><strong>Merge Sort</strong></h2>
<p><strong><code>Time Complexity</code></strong>: Log Linear O(nlog(n))</p>
<ul>
<li>Since our array gets split in half every single time we contribute O(log(n)). The while loop contained in our helper merge function contributes O(n) therefore our time complexity is O(nlog(n)); <strong><code>Space Complexity</code></strong>: O(n)</li>
<li>We are linear O(n) time because we are creating subArrays. <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/efficient_sorting_algorithms/merge_sort/images/MergeSort.gif" alt="nmer" /> <img src="https://www.geeksforgeeks.org/wp-content/uploads/Merge-Sort-Tutorial.png" alt="dmwio" /></li>
</ul>
<blockquote>
<p>Class Solution</p>
</blockquote>
<div class="sourceCode" id="cb26"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb26-1" title="1"><span class="kw">function</span> <span class="at">merge</span>(arr1<span class="op">,</span> arr2) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-2" title="2">  <span class="kw">let</span> result <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb26-3" title="3">  <span class="cf">while</span> (<span class="va">arr1</span>.<span class="at">length</span> <span class="op">&amp;&amp;</span> <span class="va">arr2</span>.<span class="at">length</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-4" title="4">    <span class="cf">if</span> (arr1[<span class="dv">0</span>] <span class="op">&lt;</span> arr2[<span class="dv">0</span>]) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-5" title="5">      <span class="va">result</span>.<span class="at">push</span>(<span class="va">arr1</span>.<span class="at">shift</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb26-6" title="6">    <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb26-7" title="7">      <span class="va">result</span>.<span class="at">push</span>(<span class="va">arr2</span>.<span class="at">shift</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb26-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb26-9" title="9">  <span class="op">}</span></a>
<a class="sourceLine" id="cb26-10" title="10">  <span class="cf">return</span> [...<span class="at">result</span><span class="op">,</span> ...<span class="at">arr1</span><span class="op">,</span> ...<span class="at">arr2</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb26-11" title="11"><span class="op">}</span></a>
<a class="sourceLine" id="cb26-12" title="12"></a>
<a class="sourceLine" id="cb26-13" title="13"><span class="kw">function</span> <span class="at">mergeSort</span>(arr) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-14" title="14">  <span class="cf">if</span> (<span class="va">arr</span>.<span class="at">length</span> <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="cf">return</span> arr<span class="op">;</span></a>
<a class="sourceLine" id="cb26-15" title="15"></a>
<a class="sourceLine" id="cb26-16" title="16">  <span class="kw">const</span> mid <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">arr</span>.<span class="at">length</span> / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb26-17" title="17">  <span class="kw">const</span> left <span class="op">=</span> <span class="at">mergeSort</span>(<span class="va">arr</span>.<span class="at">slice</span>(<span class="dv">0</span><span class="op">,</span> mid))<span class="op">;</span></a>
<a class="sourceLine" id="cb26-18" title="18">  <span class="kw">const</span> right <span class="op">=</span> <span class="at">mergeSort</span>(<span class="va">arr</span>.<span class="at">slice</span>(mid))<span class="op">;</span></a>
<a class="sourceLine" id="cb26-19" title="19"></a>
<a class="sourceLine" id="cb26-20" title="20">  <span class="cf">return</span> <span class="at">merge</span>(left<span class="op">,</span> right)<span class="op">;</span></a>
<a class="sourceLine" id="cb26-21" title="21"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="quick-sort"><strong>Quick Sort</strong></h2>
<p><strong><code>Time Complexity</code></strong>: Quadratic O(n^2)</p>
<ul>
<li>Even though the average time complexity O(nLog(n)), the worst case scenario is always quadratic.</li>
</ul>
<p><strong><code>Space Complexity</code></strong>: O(n)</p>
<ul>
<li>Our space complexity is linear O(n) because of the partition arrays we create. <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/efficient_sorting_algorithms/quick_sort/images/QuickSort.gif" alt="quick" /> <img src="https://www.w3resource.com/w3r_images/quick-sort-part-1.png" alt="qs" /></li>
</ul>
<div class="sourceCode" id="cb27"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb27-1" title="1"><span class="kw">function</span> <span class="at">quickSort</span>(array) <span class="op">{</span></a>
<a class="sourceLine" id="cb27-2" title="2">  <span class="cf">if</span> (<span class="va">array</span>.<span class="at">length</span> <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="cf">return</span> array<span class="op">;</span></a>
<a class="sourceLine" id="cb27-3" title="3"></a>
<a class="sourceLine" id="cb27-4" title="4">  <span class="kw">let</span> pivot <span class="op">=</span> <span class="va">array</span>.<span class="at">shift</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb27-5" title="5"></a>
<a class="sourceLine" id="cb27-6" title="6">  <span class="kw">let</span> left <span class="op">=</span> <span class="va">array</span>.<span class="at">filter</span>((x) <span class="kw">=&gt;</span> x <span class="op">&lt;</span> pivot)<span class="op">;</span></a>
<a class="sourceLine" id="cb27-7" title="7">  <span class="kw">let</span> right <span class="op">=</span> <span class="va">array</span>.<span class="at">filter</span>((x) <span class="kw">=&gt;</span> x <span class="op">&gt;=</span> pivot)<span class="op">;</span></a>
<a class="sourceLine" id="cb27-8" title="8"></a>
<a class="sourceLine" id="cb27-9" title="9">  <span class="kw">let</span> sortedLeft <span class="op">=</span> <span class="at">quickSort</span>(left)<span class="op">;</span></a>
<a class="sourceLine" id="cb27-10" title="10">  <span class="kw">let</span> sortedRight <span class="op">=</span> <span class="at">quickSort</span>(right)<span class="op">;</span></a>
<a class="sourceLine" id="cb27-11" title="11"></a>
<a class="sourceLine" id="cb27-12" title="12">  <span class="cf">return</span> [...<span class="at">sortedLeft</span><span class="op">,</span> pivot<span class="op">,</span> ...<span class="at">sortedRight</span>]<span class="op">;</span></a>
<a class="sourceLine" id="cb27-13" title="13"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="binary-search"><strong>Binary Search</strong></h2>
<p><strong><code>Time Complexity</code></strong>: Log Time O(log(n))</p>
<p><strong><code>Space Complexity</code></strong>: O(1) <img src="https://www.geeksforgeeks.org/wp-content/uploads/Binary-Search.png" alt="bin" /></p>
<blockquote>
<p>Recursive Solution</p>
</blockquote>
<div class="sourceCode" id="cb28"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb28-1" title="1"><span class="kw">function</span> <span class="at">binarySearch</span>(array<span class="op">,</span> target) <span class="op">{</span></a>
<a class="sourceLine" id="cb28-2" title="2">  <span class="cf">if</span> (<span class="va">array</span>.<span class="at">length</span> <span class="op">===</span> <span class="dv">0</span>) <span class="cf">return</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb28-3" title="3"></a>
<a class="sourceLine" id="cb28-4" title="4">  <span class="kw">let</span> midPt <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">array</span>.<span class="at">length</span> / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb28-5" title="5"></a>
<a class="sourceLine" id="cb28-6" title="6">  <span class="cf">if</span> (array[midPt] <span class="op">===</span> target) <span class="op">{</span></a>
<a class="sourceLine" id="cb28-7" title="7">    <span class="cf">return</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb28-8" title="8">  <span class="op">}</span> <span class="cf">else</span> <span class="cf">if</span> (list[midPt] <span class="op">&gt;</span> target) <span class="op">{</span></a>
<a class="sourceLine" id="cb28-9" title="9">    <span class="cf">return</span> <span class="at">binarySearch</span>(<span class="va">list</span>.<span class="at">slice</span>(<span class="dv">0</span><span class="op">,</span> mid)<span class="op">,</span> target)<span class="op">;</span></a>
<a class="sourceLine" id="cb28-10" title="10">  <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb28-11" title="11">    <span class="cf">return</span> <span class="at">binarySearch</span>(<span class="va">list</span>.<span class="at">slice</span>(midPt <span class="op">+</span> <span class="dv">1</span>)<span class="op">,</span> target)<span class="op">;</span></a>
<a class="sourceLine" id="cb28-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb28-13" title="13"><span class="op">}</span></a></code></pre></div>
<blockquote>
<p>Min Max Solution</p>
</blockquote>
<div class="sourceCode" id="cb29"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb29-1" title="1"><span class="kw">function</span> <span class="at">binarySearch</span>(array<span class="op">,</span> target) <span class="op">{</span></a>
<a class="sourceLine" id="cb29-2" title="2">  <span class="kw">let</span> start <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-3" title="3">  <span class="kw">let</span> end <span class="op">=</span> <span class="va">array</span>.<span class="at">length</span> <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-4" title="4"></a>
<a class="sourceLine" id="cb29-5" title="5">  <span class="cf">while</span> (start <span class="op">&lt;=</span> end) <span class="op">{</span></a>
<a class="sourceLine" id="cb29-6" title="6">    <span class="kw">let</span> midpoint <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>((start <span class="op">+</span> end) / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb29-7" title="7"></a>
<a class="sourceLine" id="cb29-8" title="8">    <span class="cf">if</span> (target <span class="op">===</span> array[midpoint]) <span class="op">{</span></a>
<a class="sourceLine" id="cb29-9" title="9">      <span class="cf">return</span> midpoint<span class="op">;</span></a>
<a class="sourceLine" id="cb29-10" title="10">    <span class="op">}</span></a>
<a class="sourceLine" id="cb29-11" title="11"></a>
<a class="sourceLine" id="cb29-12" title="12">    <span class="cf">if</span> (target <span class="op">&gt;</span> array[midpoint]) <span class="op">{</span></a>
<a class="sourceLine" id="cb29-13" title="13">      start <span class="op">=</span> midpoint <span class="op">+</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-14" title="14">    <span class="op">}</span></a>
<a class="sourceLine" id="cb29-15" title="15"></a>
<a class="sourceLine" id="cb29-16" title="16">    <span class="cf">if</span> (target <span class="op">&lt;</span> array[midpoint]) <span class="op">{</span></a>
<a class="sourceLine" id="cb29-17" title="17">      end <span class="op">=</span> midpoint <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-18" title="18">    <span class="op">}</span></a>
<a class="sourceLine" id="cb29-19" title="19">  <span class="op">}</span></a>
<a class="sourceLine" id="cb29-20" title="20">  <span class="cf">return</span> <span class="dv">-1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-21" title="21"><span class="op">}</span></a></code></pre></div>
<hr />
<h2 id="insertion-sort-1"><strong>Insertion Sort</strong></h2>
<figure>
<img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/naive_sorting_algorithms/insertion_sort/images/InsertionSort.gif" alt="insert" /><figcaption>insert</figcaption>
</figure>
<ul>
<li>Works by building a larger and larger sorted region at the left-most end of the array.</li>
<li>Steps:
<ol type="1">
<li>If it is the first element, and it is already sorted; return 1.</li>
<li>Pick next element.</li>
<li>Compare with all elements in the sorted sub list</li>
<li>Shift all the elemnts in the sorted sub list that is greater than the value to be sorted.</li>
<li>Insert the value</li>
<li>Repeat until list is sorted.</li>
</ol></li>
</ul>
<div class="sourceCode" id="cb30"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb30-1" title="1"><span class="kw">let</span> insertionSort <span class="op">=</span> (inputArr) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb30-2" title="2">  <span class="kw">let</span> length <span class="op">=</span> <span class="va">inputArr</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb30-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">1</span><span class="op">;</span> i <span class="op">&lt;</span> length<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb30-4" title="4">    <span class="kw">let</span> key <span class="op">=</span> inputArr[i]<span class="op">;</span></a>
<a class="sourceLine" id="cb30-5" title="5">    <span class="kw">let</span> j <span class="op">=</span> i <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb30-6" title="6">    <span class="cf">while</span> (j <span class="op">&gt;=</span> <span class="dv">0</span> <span class="op">&amp;&amp;</span> inputArr[j] <span class="op">&gt;</span> key) <span class="op">{</span></a>
<a class="sourceLine" id="cb30-7" title="7">      inputArr[j <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> inputArr[j]<span class="op">;</span></a>
<a class="sourceLine" id="cb30-8" title="8">      j <span class="op">=</span> j <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb30-9" title="9">    <span class="op">}</span></a>
<a class="sourceLine" id="cb30-10" title="10">    inputArr[j <span class="op">+</span> <span class="dv">1</span>] <span class="op">=</span> key<span class="op">;</span></a>
<a class="sourceLine" id="cb30-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb30-12" title="12">  <span class="cf">return</span> inputArr<span class="op">;</span></a>
<a class="sourceLine" id="cb30-13" title="13"><span class="op">};</span></a></code></pre></div>
<hr />
<h2 id="merge-sort-1"><strong>Merge Sort</strong></h2>
<figure>
<img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/efficient_sorting_algorithms/merge_sort/images/MergeSort.gif" alt="merge" /><figcaption>merge</figcaption>
</figure>
<ul>
<li>Merge sort is nlogn time.</li>
<li>We need a function for merging and a function for sorting.</li>
<li>Steps:
<ol type="1">
<li>If there is only one element in the list, it is already sorted; return the array.</li>
<li>Otherwise, divide the list recursively into two halves until it can no longer be divided.</li>
<li>Merge the smallest lists into new list in a sorted order.</li>
</ol></li>
</ul>
<div class="sourceCode" id="cb31"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb31-1" title="1"><span class="kw">const</span> merge <span class="op">=</span> (arr1<span class="op">,</span> arr2) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb31-2" title="2">  <span class="kw">let</span> sorted <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb31-3" title="3"></a>
<a class="sourceLine" id="cb31-4" title="4">  <span class="cf">while</span> (<span class="va">arr1</span>.<span class="at">length</span> <span class="op">&amp;&amp;</span> <span class="va">arr2</span>.<span class="at">length</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb31-5" title="5">    <span class="cf">if</span> (arr1[<span class="dv">0</span>] <span class="op">&lt;</span> arr2[<span class="dv">0</span>]) <span class="va">sorted</span>.<span class="at">push</span>(<span class="va">arr1</span>.<span class="at">shift</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb31-6" title="6">    <span class="cf">else</span> <span class="va">sorted</span>.<span class="at">push</span>(<span class="va">arr2</span>.<span class="at">shift</span>())<span class="op">;</span></a>
<a class="sourceLine" id="cb31-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb31-8" title="8"></a>
<a class="sourceLine" id="cb31-9" title="9">  <span class="cf">return</span> <span class="va">sorted</span>.<span class="at">concat</span>(<span class="va">arr1</span>.<span class="at">slice</span>().<span class="at">concat</span>(<span class="va">arr2</span>.<span class="at">slice</span>()))<span class="op">;</span></a>
<a class="sourceLine" id="cb31-10" title="10"><span class="op">};</span></a></code></pre></div>
<div class="sourceCode" id="cb32"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb32-1" title="1"><span class="kw">const</span> mergeSort <span class="op">=</span> (arr) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb32-2" title="2">  <span class="cf">if</span> (<span class="va">arr</span>.<span class="at">length</span> <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="cf">return</span> arr<span class="op">;</span></a>
<a class="sourceLine" id="cb32-3" title="3">  <span class="kw">let</span> mid <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>(<span class="va">arr</span>.<span class="at">length</span> / <span class="dv">2</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb32-4" title="4">    left <span class="op">=</span> <span class="at">mergeSort</span>(<span class="va">arr</span>.<span class="at">slice</span>(<span class="dv">0</span><span class="op">,</span> mid))<span class="op">,</span></a>
<a class="sourceLine" id="cb32-5" title="5">    right <span class="op">=</span> <span class="at">mergeSort</span>(<span class="va">arr</span>.<span class="at">slice</span>(mid))<span class="op">;</span></a>
<a class="sourceLine" id="cb32-6" title="6"></a>
<a class="sourceLine" id="cb32-7" title="7">  <span class="cf">return</span> <span class="at">merge</span>(left<span class="op">,</span> right)<span class="op">;</span></a>
<a class="sourceLine" id="cb32-8" title="8"><span class="op">};</span></a></code></pre></div>
<hr />
<h2 id="quick-sort-1"><strong>Quick Sort</strong></h2>
<ul>
<li>QS is another Divide and Conquer strategy.</li>
<li>Some key ideas to keep in mind:
<ul>
<li>It is easy to sort elements of an array relative to a particular target value.</li>
<li>An array of 0 or 1 elements is already trivially sorted. <img src="https://s3-us-west-1.amazonaws.com/appacademy-open-assets/data_structures_algorithms/efficient_sorting_algorithms/quick_sort/images/QuickSort.gif" alt="quicksort" /></li>
</ul></li>
</ul>
<div class="sourceCode" id="cb33"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb33-1" title="1"><span class="kw">function</span> <span class="at">quick_Sort</span>(origArray) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-2" title="2">  <span class="cf">if</span> (<span class="va">origArray</span>.<span class="at">length</span> <span class="op">&lt;=</span> <span class="dv">1</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-3" title="3">    <span class="cf">return</span> origArray<span class="op">;</span></a>
<a class="sourceLine" id="cb33-4" title="4">  <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb33-5" title="5">    <span class="kw">let</span> left <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb33-6" title="6">    <span class="kw">let</span> right <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb33-7" title="7">    <span class="kw">let</span> newArray <span class="op">=</span> []<span class="op">;</span></a>
<a class="sourceLine" id="cb33-8" title="8">    <span class="kw">let</span> pivot <span class="op">=</span> <span class="va">origArray</span>.<span class="at">pop</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb33-9" title="9">    <span class="kw">let</span> length <span class="op">=</span> <span class="va">origArray</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb33-10" title="10"></a>
<a class="sourceLine" id="cb33-11" title="11">    <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> length<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-12" title="12">      <span class="cf">if</span> (origArray[i] <span class="op">&lt;=</span> pivot) <span class="op">{</span></a>
<a class="sourceLine" id="cb33-13" title="13">        <span class="va">left</span>.<span class="at">push</span>(origArray[i])<span class="op">;</span></a>
<a class="sourceLine" id="cb33-14" title="14">      <span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb33-15" title="15">        <span class="va">right</span>.<span class="at">push</span>(origArray[i])<span class="op">;</span></a>
<a class="sourceLine" id="cb33-16" title="16">      <span class="op">}</span></a>
<a class="sourceLine" id="cb33-17" title="17">    <span class="op">}</span></a>
<a class="sourceLine" id="cb33-18" title="18"></a>
<a class="sourceLine" id="cb33-19" title="19">    <span class="cf">return</span> <span class="va">newArray</span>.<span class="at">concat</span>(<span class="at">quick_Sort</span>(left)<span class="op">,</span> pivot<span class="op">,</span> <span class="at">quick_Sort</span>(right))<span class="op">;</span></a>
<a class="sourceLine" id="cb33-20" title="20">  <span class="op">}</span></a>
<a class="sourceLine" id="cb33-21" title="21"><span class="op">}</span></a></code></pre></div>
<p><strong>binary search</strong></p>
<div class="sourceCode" id="cb34"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb34-1" title="1"><span class="kw">const</span> binarySearch <span class="op">=</span> (array<span class="op">,</span> target) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb34-2" title="2">  <span class="kw">let</span> startIndex <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb34-3" title="3">  <span class="kw">let</span> endIndex <span class="op">=</span> <span class="va">array</span>.<span class="at">length</span> <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb34-4" title="4">  <span class="cf">while</span>(startIndex <span class="op">&lt;=</span> endIndex) <span class="op">{</span></a>
<a class="sourceLine" id="cb34-5" title="5">    <span class="kw">let</span> middleIndex <span class="op">=</span> <span class="va">Math</span>.<span class="at">floor</span>((startIndex <span class="op">+</span> endIndex) / <span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb34-6" title="6">    <span class="cf">if</span>(target <span class="op">===</span> array[middleIndex) <span class="op">{</span></a>
<a class="sourceLine" id="cb34-7" title="7">      <span class="cf">return</span> <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Target was found at index &quot;</span> <span class="op">+</span> middleIndex)<span class="op">;</span></a>
<a class="sourceLine" id="cb34-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb34-9" title="9">    <span class="cf">if</span>(target <span class="op">&gt;</span> array[middleIndex]) <span class="op">{</span></a>
<a class="sourceLine" id="cb34-10" title="10">      <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Searching the right side of Array&quot;</span>)</a>
<a class="sourceLine" id="cb34-11" title="11">      startIndex <span class="op">=</span> middleIndex <span class="op">+</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb34-12" title="12">    <span class="op">}</span></a>
<a class="sourceLine" id="cb34-13" title="13">    <span class="cf">if</span>(target <span class="op">&lt;</span> array[middleIndex]) <span class="op">{</span></a>
<a class="sourceLine" id="cb34-14" title="14">      <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Searching the left side of array&quot;</span>)</a>
<a class="sourceLine" id="cb34-15" title="15">      endIndex <span class="op">=</span> middleIndex <span class="op">-</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb34-16" title="16">    <span class="op">}</span></a>
<a class="sourceLine" id="cb34-17" title="17">    <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb34-18" title="18">      <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Not Found this loop iteration. Looping another iteration.&quot;</span>)</a>
<a class="sourceLine" id="cb34-19" title="19">    <span class="op">}</span></a>
<a class="sourceLine" id="cb34-20" title="20">  <span class="op">}</span></a>
<a class="sourceLine" id="cb34-21" title="21"></a>
<a class="sourceLine" id="cb34-22" title="22">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Target value not found in array&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb34-23" title="23"><span class="op">}</span></a></code></pre></div>
<h1 id="notes"><strong>Notes</strong></h1>
<h2 id="linked-lists"><strong>Linked Lists</strong></h2>
<ul>
<li>A <strong><code>linked list</code></strong> represents a linear sequence of ‘vertices’ or ‘nodes’ and tracks three properties.
<ul>
<li><strong><code>Head</code></strong> : The first node in the list.</li>
<li><strong><code>Tail</code></strong> : The last node in the list.</li>
<li><strong><code>Length</code></strong> : The number of nodes in the list; the list’s length.</li>
</ul></li>
<li><strong><code>Nodes</code></strong> : Simpler, smaller data structure that connects the linked list.</li>
<li>Node Properties:
<ul>
<li><strong><code>Value</code></strong> : THe actual value this node represents.</li>
<li><strong><code>Next</code></strong> : The next node in the list (relative to this node).</li>
<li><strong><code>Previous</code></strong> : The previous node in the list (relative to this node).</li>
</ul></li>
</ul>
</body>
</html>
